;Kllkod fr programmer FRAKLTAL.EXE.   
;Exempel p hur man kan anvnda flyttalsenheten fr att
;rita upp och berkna Mandelbrot-fraktaler.

.MODEL SMALL
.stack 100h
.486
;------------------------------------------------------------

.Data                   ;Hr r mina data fr programmet.

video  db ?            ;Videolget som programmet anvnder

vmode  db  5bh         ;18 Videolget som programmet anvnder.
colors dw  15         ;Numert fr den hgsta frgen i videolget.
xpunkter    dw 800    ;640antal punkter i x-led
ypunkter    dw 600    ;480antal punkter i y-led

maxbelopp   dw 8       ;ver siger belopper (i kvadrat) av vrt
			;komplexa tal denna siffra anses det g
			;mot ondligheten.

maxit  equ  050h        ;Maximalt antal iterationer (hex). Hj talet om
			;du vill se mer detaljer. Snk det om du vill 
			;att programmet ska g fortare.
xmin  dd -2
ymin  dd -1.3
xmax  dd 0.8
ymax  dd 1.3

xspace dd ?
yspace dd ?

re     dd ?
im     dd ?

;---------------------------------------------------------------------------
;Hr kommer programmet
.code
	mov ax, @data
	mov ds, ax

	mov ah, 0fh      ;dessa rader tar reda p det nuvarande video
	int 010h         ;lget och sparar det i minnesvariabeln VIDEO
	mov video, al

	mov ah, 00    ;Hr stter vi skrmen till vrt valda
	mov al, vmode   ;vidolge.
	int 10h

Init:   finit           ;Vi nollstller frst flyttalsenheten.

	fld xmax        ;Sedan berknar vi avstndet mellan punkterna
	fld xmin        ;i xled
	fsub
	fild xpunkter
	fdiv
	fstp xspace     ;Resultatet sparar vi i variabeln xspace

	fld ymax        ;Berknar avstndet mellan punkterna i y-led
	fld ymin
	fsub
	fild ypunkter
	fdiv
	fstp yspace     ;sprar resultet i yspace

	fld xmin        ;Nu stller vi in programmets ingngsparametrar.       
	fld ymax        ;Vi brjar p punkten i vre vnstrar hrnet.
	mov cx, 0       ;Den har i verkligheten koordinaterna (xmin,ymax)
	mov dx, 0       ;och p skrmen koordinaterna (0,0) (=(cx,dx))
			;Nr vi gr in i programmetrs huvudslinga ligger
			;punktens Y-koordinat verst p stacken. Under
			;den ligger X-koordinaten.

Slinga: fld st(1)      ;Hr brjar vr slinga fr varje punkt.
	fstp re         ;frst sparar vi punktens verkliga vrde
	fld st(0)
	fstp im
	mov  bx, 0      ;Vi nollstller iteratioonsrknaren.

Kvadr:  fld st(1)
	fld st(2)
	fmul            ;ger x^2 verst p stacken.

	fld st(1)
	fld st(2)
	fmul            ;ger y^2 verst p stacken

	fsub            ;ger x^2 - Y^2 verst p stacken.

	fld re          ;Sedan lgger vi till det ursprungliga talets
	fadd            ;X-koordinat. Vi fr d vr nya X-koordinat.
	fxch st(2)      ;byter plats med frra iterationsens X-koordinat.
	fmul            ;ger x'y vers p stacken.
	fld st(0)       ;vi dubblerar detta vrde och fr 
	fadd            ;2*x*y verst p stacken
	fld im          ;vartefter vi lgger till vrt ursprungliga y
	fadd            ;och fr det y som vi ska anvnda i nstra iterations.

ABSett: fld st(1)    ;Nu vill vi ha absolutbeloppet av vrt nya
	fld st(2)       ;komplexa tal. Det r (med nya x och y)
	fmul            ;roten ut (x^2 + y^2), men vi njer oss med
	fld st(1)       ;talet x^2 + y^2
	fld st(2)       
	fmul
	fadd            ;nu har vi belppet i kvadrat verst p stacken.

Jmf:    fild maxbelopp  ;vi kontrollerar om beloppet i kvadrat verstiger
	fcompp          ;vrt MAXBELOPP. Nr det gjort det anser vi att
	fstsw ax        ;talet gr mot ondlighet om vi upprepsr vr
	wait            ;iteration o'ndligt mnga gnger. D tillhr talet
	sahf            ;inte mandelbrotmngden.
	jb  ut          ;hoppar till ut: om maxbelopp < st(0).

	inc bx          ;annars rknar vi upp vrt iterationstal.
	cmp bx, maxit   ;kontrollerar om vi itererat maximalt antal ggr.
	jl kvadr        ;annars kvadrerar vi talet igen.
	mov al, 0       ;stter punkter i mandelbrotmngden till svart
	jmp plot        ;och ritar ut dem p skrmen.

Ut:    ; mov ax, bx      ;Hit kommer programmet om det hoppar ut efter
;       push dx         ;ett begrnsat antal iterationer.
;       mov dx, 0       ;vi delar iterationtalet med maximala antalet
;       mov bx, colors  ;frger.
;       div bx
;       mov ax, dx      ;lgger resten frn divisionen i al
;       pop dx
	inc al          ;lgger till ett fr att frgen inte ska kunna
			;bli 0, dvs svart (som vi reserverat fr 
			;punkter i mandelbrotsmngden).

Plot:   mov ah, 0ch
	int 10h         ;anropar rutin i BIOS fr att plotta punkten.

	ffree st(1)     ;nu slpper vi vra x och y frn stackenm, eftersom
	ffree st(0)     ;vr berkning r klar fr den hr punkten.
	inc cx          ;nsta punkt i x-led
	cmp cx,xpunkter ;kontrollera om vi ntt radslut.
	je nxtrad       ;i s fall hoppar vi till nxtrad.
	fld re          ;vi rknar ut vilka tal som svarar mot nsta punkt
	fld xspace      ;p skrmen.
	fadd            ;nsta punkts x-koordinat r nu verst p stacken.
	fld im          ;punkten har samma y-koordinat som fregende punkt
	jmp slinga      ;upprepa hela proceduren med denna nya punkt.

nxtrad: mov cx, 0       ;radens slut. vi nollstller skrmens x-koordinat.
	inc dx          ;och rknar upp y-koordinaten.
	cmp dx, ypunkter
	je stop         ; har vi ntt skrmens slut?
	fld xmin        ;nej, lgg den verkliga x-koordinaten fr den
	fld im          ;frsta punkten p den nya raden p stacken.
	fld yspace      ;rkna sedan ut den nya y-koordinaten
	fsub            ;lgg den verst p stacken
	jmp slinga      ;och hoppa in i vr sliga igen.

Stop:   mov ah, 0       ;Nu har vi fyllt hela skrmen.
	int 16h
	cmp al, 020h     ;kontrollera om ngon trycker p mellanslag.
	jne stop        ;mellan slag avslutar programet

slut:   mov ah,00
	mov al, video   ;vi terstller det gamla videolget innan
	int 010h        ;vi hoppar ur programmet
	mov ax, 00
	int 21h


;---------------------------------------------------------------------
	end     ;slut p kllkoden
